
#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__

/* 4x3 matrix keyboard handler */

#include <inttypes.h>

/* the columns can be on different ports */
#define COL1PORT	PORTD
#define COL1DDR		DDRD
#define COL1MASK	8
#define COL2PORT	PORTG
#define COL2DDR		DDRG
#define COL2MASK	1
#define COL3PORT	PORTG
#define COL3DDR		DDRG
#define COL3MASK	2

/* lines are on the same port (4 consecutive pins) */
#define LINESDDR	DDRC
#define LINESPORT	PORTC
#define LINESPIN	PINC
#define LINESMASK	0x0F

/* returns pressed char */
uint8_t cooked_char(void);
uint16_t read_raw_vec(void);
void keyboard_init(void);

#endif
